#ifndef	ifmmcriticalvar_h
#define	ifmmcriticalvar_h

#include "critsect.h"
#include "ifmmedia.h"

typedef struct{
  // IvV
  bool MemoryPlay;   // ͎Đ
  bool ReturnErr;    // 킴ƃG[Ԃ
  bool StayOnTop;    // EBhEɑOʂ
  bool NoActive;     // EBhEANeBu
  bool WindowPos;    // EBhEʒuŒ
  int  WindowPosX;   // v[[̈ʒu
  int  WindowPosY;   // v[[̈ʒu
  bool Minimized;    // EBhEŏŋN
  bool PreviewMovie; // vr[
  int  PreviewPos1;  // vr[ʒu
  int  PreviewPos2;  // vr[ʒu
  bool MovieCenter;  // 𒆉ɕ\
  int  MovieSize;    // ̃TCY{
  int  MoviePosX;    // v[[̈ʒu
  int  MoviePosY;    // v[[̈ʒu
  int  MovieHeight;  // ̃JX^TCY
  int  MovieWidth;   // ̃JX^TCY
  bool DebugMode;    // t@C`FbNȂōĐ݂
  bool SusieOnly;    // SusieȊO̎gps
  bool IsSusie;      // ĂяoSusieH

  // T|[g`
  bool playable[FT_COUNT];
#define WAVEPLAY 0
#define MIDIPLAY 1
#define AVIPLAY  2
#define AIFFPLAY 3
#define MOVPLAY  4
#define MPEGPLAY 5
#define MPAPLAY  6
#define AUPLAY   7
#define WMAPLAY  8
#define WMVPLAY  9
#define ASFPLAY  10
#define OGGPLAY  11
} IFMMVAR_STRUCT;

class ifmmVar
{
public:
    ifmmVar() {};
    ~ifmmVar() {};
    bool GetIsSusie()
    {
        CriticalSection cs;
        bool ret = var.IsSusie;
        return ret;
    };
    bool GetDebugMode()
    {
        CriticalSection cs;
        bool ret = var.DebugMode;
        return ret;
    };
    bool GetMemoryPlay()
    {
        CriticalSection cs;
        bool ret = var.MemoryPlay;
        return ret;
    };
    bool GetReturnErr()
    {
        CriticalSection cs;
        bool ret = var.ReturnErr;
        return ret;
    };
    bool GetStayOnTop()
    {
        CriticalSection cs;
        bool ret = var.StayOnTop;
        return ret;
    };
    bool GetNoActive()
    {
        CriticalSection cs;
        bool ret = var.NoActive;
        return ret;
    };
    bool GetWindowPos()
    {
        CriticalSection cs;
        bool ret = var.WindowPos;
        return ret;
    };
    bool GetMinimized()
    {
        CriticalSection cs;
        bool ret = var.Minimized;
        return ret;
    };
    int  GetWindowPosX()
    {
        CriticalSection cs;
        int ret = var.WindowPosX;
        return ret;
    };
    int  GetWindowPosY()
    {
        CriticalSection cs;
        int ret = var.WindowPosY;
        return ret;
    };
    int  GetMoviePosX()
    {
        CriticalSection cs;
        int ret = var.MoviePosX;
        return ret;
    };
    int  GetMoviePosY()
    {
        CriticalSection cs;
        int ret = var.MoviePosY;
        return ret;
    };
    int  GetMovieHeight()
    {
        CriticalSection cs;
        int ret = var.MovieHeight;
        return ret;
    };
    int  GetMovieWidth()
    {
        CriticalSection cs;
        int ret = var.MovieWidth;
        return ret;
    };
    bool GetPreviewMovie()
    {
        CriticalSection cs;
        bool ret = var.PreviewMovie;
        return ret;
    };
    void GetPreviewPos(double *pd)
    {
        CriticalSection cs;
        *(pd+0) = var.PreviewPos1;
        *(pd+1) = var.PreviewPos2;
    };
    bool GetMovieCenter()
    {
        CriticalSection cs;
        bool ret = var.MovieCenter;
        return ret;
    };
    int  GetMovieSize()
    {
        CriticalSection cs;
        int ret = var.MovieSize;
        return ret;
    };
    bool GetSusieOnly()
    {
        CriticalSection cs;
        bool ret = var.SusieOnly;
        return ret;
    };
    void Getplayable(bool *pb)
    {
        CriticalSection cs;
        bool *p = pb;
        for (int i=0; i < FT_COUNT; i++) {
            *(p++) = var.playable[i];
        }
    };
    void Setallvar(IFMMVAR_STRUCT *ps)
    {
        CriticalSection cs;
        var = *ps;
    };
    void Getallvar(IFMMVAR_STRUCT *ps)
    {
        CriticalSection cs;
        *ps = var;
    };
private:
    IFMMVAR_STRUCT var;
};

#endif
