// mixerNX
//
// http://hp.vector.co.jp/authors/VA016117/mixer1.html
// NX

#ifndef mymixerctr_h
#define mymixerctr_h

#include <windows.h>
#include <mmsystem.h>

class MixerCtr
{
public:
	MixerCtr();
	~MixerCtr();
	bool InitMixer(HWND hw);
	void ReleaseMixer(void);
	bool GetMasterVolume(int *Val); //Min(0)`Max(100)
	bool SetMasterVolume(int Val);
	bool UpDownMasterVolume(int dif);
	bool GetMasterMute(bool *Val);
	bool SetMasterMute(bool Val);
	bool ReverseMasterMute(void);
private:
	bool InitMasterVolumeControl(void);
	bool InitMasterMuteControl(void);
	HMIXER		m_hMixer;
	//MIXERCAPS	m_mxcaps;
	DWORD		m_dwMinimum;
	DWORD		m_dwMaximum;
	DWORD		m_cChannels;
	DWORD		m_dwVolumeControlID;
	DWORD		m_dwMuteControlID;
};

#endif
