//---------------------------------------------------------------------------
#include <vcl.h>
#include <Registry.hpp>
#pragma hdrstop

#include "Unit1.h"
#include "Unit2.h"
#include "ifmmedia.h"
//---------------------------------------------------------------------------
#pragma package(smart_init)
#pragma resource "*.dfm"

extern ifmmVar ifmmvar;
//---------------------------------------------------------------------------
#ifdef SetDlgH
__fastcall TDialogForm::TDialogForm(HWND ParentWindow)
    : TSetDlgForm(ParentWindow)
#else
__fastcall TDialogForm::TDialogForm(TComponent* Owner)
    : TForm(Owner)
#endif
{
    //Jɕʂ̂ƂANeBuɂĂ邩Ȃ̂
    ifmmPC->ActivePage = PlayerTS;
}
//---------------------------------------------------------------------------
void __fastcall TDialogForm::CancelBClick(TObject *Sender)
{
    Close();
}
//---------------------------------------------------------------------------
void __fastcall TDialogForm::OKBClick(TObject *Sender)
{
    //ݒۑ
    var.MemoryPlay = MemPlayCB->Checked;
    var.ReturnErr  = RetErrCB->Checked;
    var.StayOnTop  = StayOnTopCB->Checked;
    var.NoActive   = NoActiveCB->Checked;
    var.WindowPos  = WindowPosCB->Checked;
    var.WindowPosX = X;
    var.WindowPosY = Y;

    if ( (MovieH != 0) && (MovieW != 0) ) {
        var.MoviePosX   = MX;
        var.MoviePosY   = MY;
        var.MovieHeight = MovieH;
        var.MovieWidth  = MovieW;
    }

    var.PreviewMovie = PreviewCB->Checked;
    var.PreviewPos1 = PrePosEdit1->Text.ToIntDef(0);
    var.PreviewPos2 = PrePosEdit2->Text.ToIntDef(5);
    var.Minimized    = MinimizedCB->Checked;
    var.MovieSize    = SizeRG->ItemIndex;
    var.MovieCenter  = CenterCB->Checked;

    var.SusieOnly = SusieOnlyCB->Checked;
    var.DebugMode = DebugCB->Checked;

    for (int i=0; i < FT_COUNT; i++) {
        var.playable[i] = SupportedCLB->Checked[i];
    }

    //܂Ƃ߂Set
    ifmmvar.Setallvar(&var);

    //WXgɕۑ
    bool ret;
    TRegistry *Reg = new TRegistry;
    //Reg->RootKey = HKEY_CURRENT_USER;
    ret = Reg->OpenKey("\\Software\\shimitei\\ifmm", true);
if (ret) {
    Reg->WriteBool("Memory",    var.MemoryPlay);
    Reg->WriteBool("Error",     var.ReturnErr);
    Reg->WriteBool("StayOnTop", var.StayOnTop);
    Reg->WriteBool("NoActive",  var.NoActive);
    Reg->WriteBool("WindowPos", var.WindowPos);
    Reg->WriteInteger("WindowPosX", var.WindowPosX);
    Reg->WriteInteger("WindowPosY", var.WindowPosY);

if (MovieH != 0 && MovieW != 0) {
    Reg->WriteInteger("MoviePosX", var.MoviePosX);
    Reg->WriteInteger("MoviePosY", var.MoviePosY);
    Reg->WriteInteger("MovieHeight", var.MovieHeight);
    Reg->WriteInteger("MovieWidth",  var.MovieWidth);
}

    Reg->WriteBool("PreviewMovieFrame", var.PreviewMovie);
    Reg->WriteInteger("PreviewPos1", var.PreviewPos1);
    Reg->WriteInteger("PreviewPos2", var.PreviewPos2);
    Reg->WriteBool("Minimized", var.Minimized);
    Reg->WriteInteger("MovieSize", var.MovieSize);
    Reg->WriteBool("MovieCenter", var.MovieCenter);

    Reg->WriteBool("SusieOnly", var.SusieOnly);
    Reg->WriteBool("Debug", var.DebugMode);

    Reg->WriteBool("WAVE", var.playable[WAVEPLAY]);
    Reg->WriteBool("MIDI", var.playable[MIDIPLAY]);
    Reg->WriteBool("AVI",  var.playable[AVIPLAY]);
    Reg->WriteBool("AIFF", var.playable[AIFFPLAY]);
    Reg->WriteBool("MOV",  var.playable[MOVPLAY]);
    Reg->WriteBool("MPEG", var.playable[MPEGPLAY]);
    Reg->WriteBool("MPA",  var.playable[MPAPLAY]);
    Reg->WriteBool("AU",   var.playable[AUPLAY]);
    Reg->WriteBool("WMA",  var.playable[WMAPLAY]);
    Reg->WriteBool("WMV",  var.playable[WMVPLAY]);
    Reg->WriteBool("ASF",  var.playable[ASFPLAY]);
    Reg->WriteBool("OGG",  var.playable[OGGPLAY]);
    Reg->CloseKey();

} else {
    ShowMessage("WXgG[!\nݒۑł܂B");
}
    delete Reg;

    Close();
}
//---------------------------------------------------------------------------
void __fastcall TDialogForm::WindowPosBClick(TObject *Sender)
{
    //ijv[[EBhEʒu
    TPlayForm* PlayForm = new TPlayForm(this);

    PlayForm->Left = 0;
    PlayForm->Top  = 0;

    PlayForm->ShowModal();

    X = PlayForm->Left;
    Y = PlayForm->Top;

    delete PlayForm;
}
//---------------------------------------------------------------------------
void __fastcall TDialogForm::L1DblClick(TObject *Sender)
{
    Tag++;
    if (Tag > 5) {
        //BIvVo
        DebugCB->Visible = true;
    }
}
//---------------------------------------------------------------------------
void __fastcall TDialogForm::L1MouseDown(TObject *Sender,
      TMouseButton Button, TShiftState Shift, int X, int Y)
{
    if (Shift.Contains(ssShift) && Shift.Contains(ssRight)) {
        //BIvVݒ\
        DebugCB->Enabled = true;
    }
}
//---------------------------------------------------------------------------
void __fastcall TDialogForm::CustomBClick(TObject *Sender)
{
    //ijv[[EBhEʒuTCY
    TPlayForm* PlayForm = new TPlayForm(this);

    PlayForm->PopupMenu = NULL;
    PlayForm->ScrollBox->OnClick = NULL;
    PlayForm->OnResize = PlayForm->FormResizeEx;
    PlayForm->BorderStyle = bsSizeable;

#define DEFAULT_WIDTH 260
    PlayForm->ClientHeight += Screen->DesktopHeight * 2 / 3 +2;
    PlayForm->ClientWidth  += Screen->DesktopWidth  * 2 / 3 +2 - DEFAULT_WIDTH ;
    PlayForm->Top    = (Screen->DesktopHeight -PlayForm->Height) /2;
    PlayForm->Left   = (Screen->DesktopWidth -PlayForm->Width) /2;

    PlayForm->ShowModal();

    MX = PlayForm->Left;
    MY = PlayForm->Top;
    MovieH = PlayForm->MovieP->Height -2;
    MovieW = PlayForm->MovieP->Width  -2;

    delete PlayForm;
}
//---------------------------------------------------------------------------
void __fastcall TDialogForm::FormInit(void)
{
//Ń_CAȌs
//ݒɃ`FbNꂽƂ
    ifmmvar.Getallvar(&var);
    X = var.WindowPosX;
    Y = var.WindowPosY;

    MemPlayCB->Checked   = var.MemoryPlay;
    RetErrCB->Checked    = var.ReturnErr;
    StayOnTopCB->Checked = var.StayOnTop;
    NoActiveCB->Checked  = var.NoActive;
    WindowPosCB->Checked = var.WindowPos;

    PreviewCB->Checked   = var.PreviewMovie;
    PrePosEdit1->Text    = var.PreviewPos1;
    PrePosEdit2->Text    = var.PreviewPos2;
    MinimizedCB->Checked = var.Minimized;
    SizeRG->ItemIndex    = var.MovieSize;
    CenterCB->Checked    = var.MovieCenter;

    SusieOnlyCB->Checked = var.SusieOnly;
    DebugCB->Checked     = var.DebugMode;

    for (int i=0; i < FT_COUNT; i++) {
        SupportedCLB->Checked[i] = var.playable[i];
    }

    TStringList* AppSL = new TStringList();
    GetSusieCompatiAppName(AppSL);
    AppLB->Items->AddStrings(AppSL);
    delete AppSL;
}
//---------------------------------------------------------------------------
void __fastcall TDialogForm::AppAddButtonClick(TObject *Sender)
{
    //WXgɓo^
    TRegistry *Reg = new TRegistry;
    //Reg->RootKey = HKEY_CURRENT_USER;
    bool ret = Reg->OpenKey("\\Software\\shimitei\\ifmm\\SusieCompati", true);
    //AppSL->Clear();
if (ret) {
    AnsiString dataname = AppEdit->Text;
    if (dataname != "") {
        Reg->WriteInteger(dataname, 0);
        AppLB->Items->Add(dataname);
        AppEdit->Text = "";
    }
} else {
    ShowMessage("WXgI[vG[I");
}
    delete Reg;
}
//---------------------------------------------------------------------------
void __fastcall TDialogForm::AppDelButtonClick(TObject *Sender)
{
    int index = AppLB->ItemIndex;
    if (index == -1) return;

    //WXg폜
    TRegistry *Reg = new TRegistry;
    //Reg->RootKey = HKEY_CURRENT_USER;
    bool ret = Reg->OpenKey("\\Software\\shimitei\\ifmm\\SusieCompati", false);
if (ret) {
    if (Reg->DeleteValue(AppLB->Items->Strings[index])) {
        AppLB->Items->Delete(index);
    } else {
        //ShowMessage("폜ɎsI");
    }
} else {
    ShowMessage("WXgI[vG[I");
}
    delete Reg;
}
//---------------------------------------------------------------------------

