//---------------------------------------------------------------------------
#include <vcl.h>
#include <Registry.hpp>
#pragma hdrstop

#include "ifmmedia.h"
#include "ifmmvar.h"
#include "Unit2.h"
//---------------------------------------------------------------------------
USEFORM("Unit1.cpp", PlayForm);
USEFORM("Unit2.cpp", DialogForm);
//---------------------------------------------------------------------------
int   __fastcall GetPictureEx(const LPSTR buf, const long len, const unsigned int flag,
                   HANDLE *pHBInfo, HANDLE *pHBm,
                   const SPI_PROGRESS lpPrgressCallback,
                   const long lData, const bool IsPreview);

//O[oϐ
ifmmVar ifmmvar;
//---------------------------------------------------------------------------
int WINAPI DllEntryPoint(HINSTANCE hinst, unsigned long reason, void*)
{
    switch (reason) {
        case DLL_PROCESS_ATTACH:
            LoadOptions();
            break;
    }

    return 1;
}
//---------------------------------------------------------------------------
//ݒǂ݂
void __fastcall LoadOptions(void)
{
    IFMMVAR_STRUCT var;

/* ftHg̐ݒ */
    // ɓinjĐ
    var.MemoryPlay = true;
    // 킴ƃG[Ԃ
    var.ReturnErr  = false;
    // EBhEɑO
    var.StayOnTop  = false;
    // v[[ANeBu
    var.NoActive   = false;
    // v[[ʒuŒ
    var.WindowPos  = false;
    var.WindowPosX = 0;
    var.WindowPosY = 0;
    // v[[ŏŋN
    var.Minimized  = false;
    // Susieɓ̍ŏ̃t[Ԃ
    var.PreviewMovie = false;
    // ̃vr[ʒu(b)
    var.PreviewPos1 = 0;
    var.PreviewPos2 = 5;
    // ʒɕ\
    var.MovieCenter = false;
    // ̃TCY{
    var.MovieSize = MS_X1;
    // debugƂ...
    var.DebugMode = false;
    // Susie݊ȊOgps
    var.SusieOnly = true;

    // JX^TCY
    var.MovieHeight = Screen->DesktopHeight * 2 / 3;
    var.MovieWidth  = Screen->DesktopWidth  * 2 / 3;
    var.MoviePosY = ( (Screen->DesktopHeight -var.MovieHeight -78/*PlayForm->Height*/) /2 );
    var.MoviePosX = ( (Screen->DesktopWidth  -var.MovieWidth  -(284 -276)/*PlayForm->Width  -PlayForm->ClientWidth*/)  /2 );

    //uSusie݊vH
    /*
      Susie ̂悤ɃJ^OiTlCj쐬Ƃ GetPreviewA
      ʂɕ\Ƃ GetPicture ĂяoB
      ܂ ifmm.spi ɓ삷邱ƂmFĂ\tgB
      vOCĂяoexe̖OŃ`FbN
      "susie"܂"ccnn"܂܂ĂΗǂ
      ̃\tg̓WXgɓo^
    */
    AnsiString exename = ExtractFileName(ParamStr(0)).LowerCase();
    if (  exename.AnsiPos("susie")
       || exename.AnsiPos("ccnn")
       )
    {
        var.IsSusie = true;
    } else {
        var.IsSusie = false;
        //WXgSusie݊`FbN
        TStringList* AppSL = new TStringList();
        GetSusieCompatiAppName(AppSL);
        int count = AppSL->Count;
        for (int i=0; i < count; i++) {
            if (exename.AnsiPos(AppSL->Strings[i])) {
                var.IsSusie = true;
                break;
            }
        }
        delete AppSL;
    }

    //T|[g`
    for (int i=0; i < FT_COUNT; i++) {
        var.playable[i] = true;
    }
    //̂̓ftHg̓It
    var.playable[MOVPLAY] = false;
    var.playable[OGGPLAY] = false;


/* ݒWXgǂ݂ */
    bool ret;
    TRegistry *Reg = new TRegistry(KEY_EXECUTE);
    //Reg->RootKey = HKEY_CURRENT_USER;
    ret = Reg->OpenKey("\\Software\\shimitei\\ifmm", false);
try {
if (ret) {
    // ɓinjĐ
    if (Reg->ValueExists("Memory")) {
        var.MemoryPlay = Reg->ReadBool("Memory");
    }
    // 킴ƃG[Ԃ
    if (Reg->ValueExists("Error")) {
        var.ReturnErr = Reg->ReadBool("Error");
    }
    // EBhEɑO
    if (Reg->ValueExists("StayOnTop")) {
        var.StayOnTop = Reg->ReadBool("StayOnTop");
    }
    // v[[ANeBu
    if (Reg->ValueExists("NoActive")) {
        var.NoActive = Reg->ReadBool("NoActive");
    }
    // v[[ʒuŒ
    if (Reg->ValueExists("WindowPos")) {
        var.WindowPos = Reg->ReadBool("WindowPos");
    }
    if (Reg->ValueExists("WindowPosX")) {
        var.WindowPosX = Reg->ReadInteger("WindowPosX");
    }
    if (Reg->ValueExists("WindowPosY")) {
        var.WindowPosY = Reg->ReadInteger("WindowPosY");
    }

    // Susieɓ̍ŏ̃t[Ԃ
    if (Reg->ValueExists("PreviewMovieFrame")) {
        var.PreviewMovie = Reg->ReadBool("PreviewMovieFrame");
    }
    // ̃vr[ʒu
    if (Reg->ValueExists("PreviewPos1")) {
        var.PreviewPos1 = Reg->ReadInteger("PreviewPos1");
    }
    if (Reg->ValueExists("PreviewPos2")) {
        var.PreviewPos2 = Reg->ReadInteger("PreviewPos2");
    }
    // v[[ŏŋN
    if (Reg->ValueExists("Minimized")) {
        var.Minimized = Reg->ReadBool("Minimized");
    }
    // ̃TCY{
    if (Reg->ValueExists("MovieSize")) {
        var.MovieSize = Reg->ReadInteger("MovieSize");
    }
    // ʒ
    if (Reg->ValueExists("MovieCenter")) {
        var.MovieCenter = Reg->ReadBool("MovieCenter");
    }

    int tmpX = 0;
    int tmpY = 0;
    int tmpH = 0;
    int tmpW = 0;
    // JX^TCY
    if (Reg->ValueExists("MoviePosX")) {
        tmpX = Reg->ReadInteger("MoviePosX");
    }
    if (Reg->ValueExists("MoviePosY")) {
        tmpY = Reg->ReadInteger("MoviePosY");
    }
    if (Reg->ValueExists("MovieHeight")) {
        tmpH = Reg->ReadInteger("MovieHeight");
    }
    if (Reg->ValueExists("MovieWidth")) {
        tmpW = Reg->ReadInteger("MovieWidth");
    }
    if (tmpH != 0 && tmpW != 0) {
        var.MoviePosX = tmpX;
        var.MoviePosY = tmpY;
        var.MovieHeight = tmpH;
        var.MovieWidth  = tmpW;
    }

    // Susie݊ȊOgps
    if (Reg->ValueExists("SusieOnly")) {
        var.SusieOnly = Reg->ReadBool("SusieOnly");
    }
    // fobO[h
    if (Reg->ValueExists("Debug")) {
        var.DebugMode = Reg->ReadBool("Debug");
    }

    // T|[g`
    if (Reg->ValueExists("WAVE")) {
        var.playable[WAVEPLAY] = Reg->ReadBool("WAVE");
    }
    if (Reg->ValueExists("MIDI")) {
        var.playable[MIDIPLAY] = Reg->ReadBool("MIDI");
    }
    if (Reg->ValueExists("AVI")) {
        var.playable[AVIPLAY] = Reg->ReadBool("AVI");
    }
    if (Reg->ValueExists("AIFF")) {
        var.playable[AIFFPLAY] = Reg->ReadBool("AIFF");
    }
    if (Reg->ValueExists("MOV")) {
        var.playable[MOVPLAY] = Reg->ReadBool("MOV");
    }
    if (Reg->ValueExists("MPEG")) {
        var.playable[MPEGPLAY] = Reg->ReadBool("MPEG");
    }
    if (Reg->ValueExists("MPA")) {
        var.playable[MPAPLAY] = Reg->ReadBool("MPA");
    }
    if (Reg->ValueExists("AU")) {
        var.playable[AUPLAY] = Reg->ReadBool("AU");
    }
    if (Reg->ValueExists("WMA")) {
        var.playable[WMAPLAY] = Reg->ReadBool("WMA");
    }
    if (Reg->ValueExists("WMV")) {
        var.playable[WMVPLAY] = Reg->ReadBool("WMV");
    }
    if (Reg->ValueExists("ASF")) {
        var.playable[ASFPLAY] = Reg->ReadBool("ASF");
    }
    if (Reg->ValueExists("OGG")) {
        var.playable[OGGPLAY] = Reg->ReadBool("OGG");
    }
    Reg->CloseKey();
}
} catch (...) {
    //throw;
}
    delete Reg;

    //܂Ƃ߂Set
    ifmmvar.Setallvar(&var);
}
//---------------------------------------------------------------------------
//Susie݊o^Avǂ
//֐...
void __fastcall GetSusieCompatiAppName(TStringList* AppSL)
{
    TRegistry *Reg = new TRegistry(KEY_EXECUTE);
    //Reg->RootKey = HKEY_CURRENT_USER;
    bool ret = Reg->OpenKey("\\Software\\shimitei\\ifmm\\SusieCompati", false);
    //AppSL->Clear();
if (ret) {
    Reg->GetValueNames(AppSL);
}
    delete Reg;
}
//---------------------------------------------------------------------------
int __stdcall GetPluginInfo(int infono, LPSTR buf, int buflen)
{
    char filemask[6*FT_COUNT+1];
    char *str;
    char *infomation[] = {
    /* 0     */  "00IN",
    /* 1     */  "MediaPlayer v1.24b by shimitei",
    /* 2*0+2 */  NULL, /* filemask */
    /* 2*0+3 */  "Media file",
    };

    if (infono < 0) return 0;
    if (infono < (sizeof(infomation) / sizeof(infomation[0]))) {
        if (infono == 2) {
            bool playable[FT_COUNT];
            ifmmvar.Getplayable(playable);
            filemask[0] = '\0';
            if (playable[WAVEPLAY]) strcat(filemask, "*.wav;");
            if (playable[MIDIPLAY]) strcat(filemask, "*.mid;");
            if (playable[AVIPLAY] ) strcat(filemask, "*.avi;");
            if (playable[AIFFPLAY]) strcat(filemask, "*.aif;");
            if (playable[MOVPLAY] ) strcat(filemask, "*.mov;");
            if (playable[MPEGPLAY]) strcat(filemask, "*.mpg;");
            if (playable[MPAPLAY] ) strcat(filemask, "*.mp3;");
            if (playable[AUPLAY]  ) strcat(filemask, "*.au;");
            if (playable[WMAPLAY] ) strcat(filemask, "*.wma;");
            if (playable[WMVPLAY] ) strcat(filemask, "*.wmv;");
            if (playable[ASFPLAY] ) strcat(filemask, "*.asf;");
            if (playable[OGGPLAY] ) strcat(filemask, "*.ogg;");

            if (filemask[0] != '\0') {
                //Ō";"BKv͖H
                size_t fmsize = strlen(filemask) -1;
                filemask[fmsize] = '\0';
            }
            str  = filemask;
        } else {
            str  = infomation[infono];
        }
        //񎁐݊
        //K'\0'H
        lstrcpyn(buf, str, buflen);
        //'\0'͐Ȃ
        return lstrlen(buf);
    }

    return 0;
}
//---------------------------------------------------------------------------
int __stdcall IsSupported(LPSTR filename, DWORD dw)
{
    char h_buff[HEAD_BUFF];
    char *data;

    if ((dw & 0xFFFF0000) == 0) {
    /* t@Cnh */
        DWORD ReadBytes;
        memset(h_buff, 0, HEAD_BUFF);
        if (!ReadFile((HANDLE)dw, h_buff, HEAD_BUFF, &ReadBytes, NULL)) {
            return 0;
        }
        data = h_buff;
    } else {
    /*  */
        data = (char *)dw;
    }

    /* Ήt@CmF */
    if (GetFileType(data, filename) != FT_UNKNOWN) {
        return 1;
    }

    return 0;
}
//---------------------------------------------------------------------------
int __stdcall GetPictureInfo
(LPSTR buf, long len, unsigned int flag, struct PictureInfo *lpInfo)
{
    //ŒԂ
    char h_buff[HEAD_BUFF];
    char *data;
    char *filename;

switch ((flag & 7)) {
    case 0: /* t@C */
    {
        HANDLE hf;
        DWORD ReadBytes;
        hf = CreateFile(buf, GENERIC_READ, FILE_SHARE_READ, NULL, OPEN_EXISTING, 0, NULL);
        if (hf == INVALID_HANDLE_VALUE)
            return SPI_FILE_READ_ERROR;
        //SetFilePointer(hf, len, NULL, FILE_BEGIN);//MacoCiɂ͑ΉȂ
        if (!ReadFile(hf, h_buff, HEAD_BUFF, &ReadBytes, NULL)) {
            CloseHandle(hf);
            return SPI_FILE_READ_ERROR;
        }
        CloseHandle(hf);
        data = h_buff;
        filename = buf;
        break;
    }
    case 1: /*  */
        data = buf;
        filename = NULL;
        break;
    default:
        return SPI_NO_FUNCTION;
}

    /* Ήt@CmF */
    if (GetFileType(data, filename) == FT_UNKNOWN) return SPI_NOT_SUPPORT;

    lpInfo->left       = 0;
    lpInfo->top        = 0;
    lpInfo->width      = 32;
    lpInfo->height     = 32;
    lpInfo->x_density  = 0;
    lpInfo->y_density  = 0;
    lpInfo->colorDepth = 24;
    lpInfo->hInfo      = NULL;

    return SPI_ALL_RIGHT;
}
//---------------------------------------------------------------------------
//GetPreviewGetPicturȅ܂Ƃ߂
int __fastcall GetPictureEx(
        const LPSTR buf, const long len, const unsigned int flag,
        HANDLE *pHBInfo, HANDLE *pHBm,
        const SPI_PROGRESS lpPrgressCallback,
        const long lData, const bool IsPreview)
{
    char h_buff[HEAD_BUFF];
    char *data;
    char *filename;
    bool inmem;

switch (flag & 7) {
    case 0: /* t@C */
    {
        HANDLE hf;
        DWORD ReadBytes;
        hf = CreateFile(buf, GENERIC_READ, FILE_SHARE_READ, NULL, OPEN_EXISTING, 0, NULL);
        if (hf == INVALID_HANDLE_VALUE)
            return SPI_FILE_READ_ERROR;
        //SetFilePointer(hf, len, NULL, FILE_BEGIN);//MacoCiΉ
        if (!ReadFile(hf, h_buff, HEAD_BUFF, &ReadBytes, NULL)) {
            CloseHandle(hf);
            return SPI_FILE_READ_ERROR;
        }
        CloseHandle(hf);
        inmem = false;
        filename = buf;
        data = h_buff;
        break;
    }
    case 1: /*  */
        //ɓinjĐH
        if (!ifmmvar.GetMemoryPlay()) {
            return SPI_NOT_SUPPORT;
        }
        data = buf;
        inmem = true;
        filename = NULL;
        break;
    default:
        return SPI_NO_FUNCTION;
}

    /* Ήt@CmF */
    unsigned int filetype = GetFileType(data, filename);
    if (filetype == FT_UNKNOWN) return SPI_NOT_SUPPORT;

    char tempfname[MAX_PATH] = "";
    //vr[łȂ΍Đ
    if (!IsPreview) {
        if (inmem) {
            if (!PutTempFile(tempfname, buf, len))
                return SPI_FILE_READ_ERROR;
        } else {
            strcat(tempfname, buf);
        }
        int ret = MediaPlay(tempfname, inmem, filetype, lpPrgressCallback, lData);
        if (inmem) DeleteFile(tempfname);
        if (ret != SPI_ALL_RIGHT) return ret;
        //"킴ƃG["ԂBԂ̂͂ȂƂȂuG[v
        if (ifmmvar.GetReturnErr()) return SPI_OTHER_ERROR;
    }

    bool ret;
    if (   !ifmmvar.GetPreviewMovie()
        || !IsPreview
        || !IS_MOVIE(filetype)
       ) {
        ret = GetFileIcon(pHBInfo, pHBm, filetype);
        if (!ret) return SPI_OTHER_ERROR;
    } else {
        if (inmem) {
            if (!PutTempFile(tempfname, buf, len))
                return SPI_FILE_READ_ERROR;
            ret = GetMovieFrame(tempfname, pHBInfo, pHBm);
            DeleteFile(tempfname);
        } else {
            strcpy(tempfname, buf);
            ret = GetMovieFrame(tempfname, pHBInfo, pHBm);
        }
        if (!ret) {
            ret = GetFileIcon(pHBInfo, pHBm, filetype);
            if (!ret) return SPI_OTHER_ERROR;
        }
    }

    return SPI_ALL_RIGHT;
}
//---------------------------------------------------------------------------
int __stdcall GetPicture(
        LPSTR buf, long len, unsigned int flag,
        HANDLE *pHBInfo, HANDLE *pHBm,
        SPI_PROGRESS lpPrgressCallback, long lData)
{
if (!ifmmvar.GetIsSusie() && ifmmvar.GetSusieOnly()) {
    //Susie݊ȊO
    return GetPreview(buf, len, flag, pHBInfo, pHBm, lpPrgressCallback, lData);
}
    //Susie݊
    return GetPictureEx(buf, len, flag, pHBInfo, pHBm, lpPrgressCallback, lData, false);
}
//---------------------------------------------------------------------------
int __stdcall GetPreview(
    LPSTR buf, long len, unsigned int flag,
    HANDLE *pHBInfo, HANDLE *pHBm,
    SPI_PROGRESS lpPrgressCallback, long lData)
{
    if (lpPrgressCallback != NULL)
        if (lpPrgressCallback(0, 1, lData)) // 0%
            return SPI_ABORT;

    int ret = GetPictureEx(buf, len, flag, pHBInfo, pHBm, lpPrgressCallback, lData, true);

    if (lpPrgressCallback != NULL)
        if (lpPrgressCallback(1, 1, lData)) // 100%
            return SPI_ABORT;

    return ret;
}
//---------------------------------------------------------------------------
int __stdcall ConfigurationDlg(HWND parent, int fnc)
{
//#define SPI_CFGDLG_ABOUT    0
#define SPI_CFGDLG_SETTING  1
//#define SPI_CFGDLG_RESERVED 2

    TDialogForm *DialogForm;

    if (fnc == SPI_CFGDLG_SETTING) {
#ifdef SetDlgH
        DialogForm = new TDialogForm(parent);
#else
        DialogForm = new TDialogForm(NULL);
#endif
        DialogForm->FormInit();
        DialogForm->ShowModal();
        delete DialogForm;
        return SPI_ALL_RIGHT;
    }
    return SPI_NO_FUNCTION;
}
//---------------------------------------------------------------------------



